

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.4. grn_cache &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.25.5. grn_column" href="grn_column.html" />
    <link rel="prev" title="7.25.3. Plugin" href="plugin.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/api/grn_cache.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="grn_column.html" title="7.25.5. grn_column"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="plugin.html" title="7.25.3. Plugin"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.4. </span><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-cache">
<h1><span class="section-number">7.25.4. </span><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code><a class="headerlink" href="#grn-cache" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.4.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="admonition note">
<p class="admonition-title">注釈</p>
<p>このAPIは実験的です。</p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> は <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドのレスポンスを保持するためのデータストアです。一般的なオブジェクトのキャッシュとして使うものではありません。あくまで <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドのためのものです。</p>
<p><a class="reference internal" href="#c.grn_cache_current_set" title="grn_cache_current_set"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_current_set()</span></code></a> を使うことで現在のキャッシュオブジェクトを変更することができます。 <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドのレスポンスが内部的に用いられます。</p>
<p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドは、一つのグローバルキャッシュオブジェクトを利用します。もし複数のデータベースをオープンしていた場合、そのキャッシュオブジェクトは共有されます。これは重要な問題です。</p>
<p>もし複数のデータベースを開き、 <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドを使用するのであれば、 <code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> オブジェクトを使う必要があります。 <a class="reference internal" href="../executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a> のようなケースが該当します。もし一つのデータベースのみを開く場合や、 <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドを使わない場合は、 <code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> オブジェクトを使う必要はありません。 <a class="reference external" href="http://ranguba.org/ja/#about-rroonga">Rroonga</a> のようなケースです。</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.4.2. </span>例<a class="headerlink" href="#example" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>以下はキャッシュを変更する例です。</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_cache</span> <span class="o">*</span><span class="n">cache</span><span class="p">;</span>
<span class="n">grn_cache</span> <span class="o">*</span><span class="n">cache_previous</span><span class="p">;</span>
<span class="n">cache</span> <span class="o">=</span> <span class="n">grn_cache_open</span><span class="p">(</span><span class="n">ctx</span><span class="p">);</span>
<span class="n">cache_previous</span> <span class="o">=</span> <span class="n">grn_cache_current_get</span><span class="p">(</span><span class="n">ctx</span><span class="p">);</span>
<span class="n">grn_cache_current_set</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="n">cache</span><span class="p">);</span>
<span class="cm">/* grn_ctx_send(ctx, ...); */</span>
<span class="n">grn_cache_current_set</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="n">cache_previous</span><span class="p">);</span>
</pre></div>
</div>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.4.3. </span>リファレンス<a class="headerlink" href="#reference" title="このヘッドラインへのパーマリンク">¶</a></h2>
<dl class="c type">
<dt id="c.grn_cache">
<em class="property">type </em><code class="sig-name descname">grn_cache</code><a class="headerlink" href="#c.grn_cache" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> は詳細を公開していないオブジェクトです。 <a class="reference internal" href="#c.grn_cache_open" title="grn_cache_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_open()</span></code></a> で作成し、 <a class="reference internal" href="#c.grn_cache_close" title="grn_cache_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_close()</span></code></a> で解放できます。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_open">
<a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<code class="sig-name descname">grn_cache_open</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_open" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>新規にキャッシュオブジェクトを作成します。</p>
<p>新しいキャッシュオブジェクト作成のためのメモリ割り当てに失敗した場合、 <code class="docutils literal notranslate"><span class="pre">NULL</span></code> を返します。エラー情報は <code class="docutils literal notranslate"><span class="pre">ctx</span></code> に格納されます。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>新しいキャッシュオブジェクトの作成に成功した場合は <code class="docutils literal notranslate"><span class="pre">NULL</span></code> 以外の値を返します。このキャッシュオブジェクトは <a class="reference internal" href="#c.grn_cache_close" title="grn_cache_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_close()</span></code></a> で解放されなければなりません。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_close">
grn_rc <code class="sig-name descname">grn_cache_close</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_close" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><code class="docutils literal notranslate"><span class="pre">cache</span></code> のリソースを解放。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>cache</strong> -- キャッシュオブジェクトを解放する。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_current_set">
grn_rc <code class="sig-name descname">grn_cache_current_set</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_current_set" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドで使われるキャッシュオブジェクトを設定します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>cache</strong> -- <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドで使われるキャッシュオブジェクト。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_current_get">
<a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<code class="sig-name descname">grn_cache_current_get</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_current_get" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドで使われるキャッシュオブジェクトを取得します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドで使われるキャッシュオブジェクト。 <code class="docutils literal notranslate"><span class="pre">NULL</span></code> のこともあります。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_set_max_n_entries">
grn_rc <code class="sig-name descname">grn_cache_set_max_n_entries</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em>, unsigned int <em>n</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_set_max_n_entries" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>キャッシュオブジェクトのエントリの最大数を設定します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>cache</strong> -- 変更するキャッシュオブジェクト。</p></li>
<li><p><strong>n</strong> -- キャッシュオブジェクトの新しい最大エントリ数。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_get_max_n_entries">
unsigned int <code class="sig-name descname">grn_cache_get_max_n_entries</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_get_max_n_entries" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>キャッシュオブジェクトのエントリの最大数を取得します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>cache</strong> -- ターゲットキャッシュオブジェクト。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>キャッシュオブジェクトの最大エントリ数。</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.4. <code class="docutils literal notranslate"><span class="pre">grn_cache</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.4.1. 概要</a></li>
<li><a class="reference internal" href="#example">7.25.4.2. 例</a></li>
<li><a class="reference internal" href="#reference">7.25.4.3. リファレンス</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="plugin.html"
                        title="前の章へ"><span class="section-number">7.25.3. </span>Plugin</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="grn_column.html"
                        title="次の章へ"><span class="section-number">7.25.5. </span><code class="docutils literal notranslate"><span class="pre">grn_column</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="grn_column.html" title="7.25.5. grn_column"
             >次へ</a> |</li>
        <li class="right" >
          <a href="plugin.html" title="7.25.3. Plugin"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.4. </span><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>